Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.digester3.plugins.strategies
Class FinderFromResource

    java.lang.Object
      org.apache.commons.digester3.plugins.RuleFinder
          org.apache.commons.digester3.plugins.strategies.FinderFromResource

    public class FinderFromResource

extends RuleFinder

A rule-finding algorithm which expects the user to specify a resource name (ie a file in the classpath). The file is expected to contain Digester rules in xmlrules format.

Since:
  1.6

Constructor Summary
`FinderFromResource()` Constructor.
`FinderFromResource(String resourceAttr)` See `findLoader(org.apache.commons.digester3.Digester, java.lang.Class, java.util.Properties)`.

Method Summary
`RuleLoader` | `findLoader(Digester d, Class<?> pluginClass, Properties p)` If there exists a property with the name matching constructor param resourceAttr, then load that file, run it through the xmlrules module and return an object encapsulating those rules.
`static RuleLoader` | `loadRules(Digester d, Class<?> pluginClass, InputStream is, String resourceName)` Open the specified resource file (ie a file in the classpath, including being within a jar in the classpath), run it through the xmlrules module and return an object encapsulating those rules.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FinderFromResource

    public FinderFromResource()

  Constructor.

### FinderFromResource

    public FinderFromResource(String resourceAttr)

  See `findLoader(org.apache.commons.digester3.Digester, java.lang.Class, java.util.Properties)`.

  Parameters:
    `resourceAttr` - Name of xml attribute on the plugin declaration which is used to configure rule-loading for that declaration

Method Detail

### findLoader

    public RuleLoader findLoader(Digester d,
                                 Class<?> pluginClass,
                                 Properties p)
                          throws PluginException

  If there exists a property with the name matching constructor param resourceAttr, then load that file, run it through the xmlrules module and return an object encapsulating those rules.

  If there is no matching property provided, then just return null.

  The returned object (when non-null) will add the selected rules to the digester whenever its addRules method is invoked.

  Specified by:
    `findLoader` in class `RuleFinder`
  Parameters:
    `d` - The digester instance where locating plugin classes
    `pluginClass` - The plugin Java class
    `p` - The properties object that holds any xml attributes the user may have specified on the plugin declaration in order to indicate how to locate the plugin rules.
  Returns:
    a source of digester rules for the specified plugin class.
  Throws:
    `PluginException` - if the algorithm finds a source of rules, but there is something invalid about that source.

### loadRules

    public static RuleLoader loadRules(Digester d,
                                       Class<?> pluginClass,
                                       InputStream is,
                                       String resourceName)
                                throws PluginException

  Open the specified resource file (ie a file in the classpath, including being within a jar in the classpath), run it through the xmlrules module and return an object encapsulating those rules.

  Parameters:
    `d` - is the digester into which rules will eventually be loaded.
    `pluginClass` - is the class whose xml params the rules are parsing.
    `is` - is where the xmlrules will be read from, and must be non-null.
    `resourceName` - is a string describing the source of the xmlrules, for use in generating error messages.
  Returns:
    a source of digester rules for the specified plugin class.
  Throws:
    `PluginException` - if any error occurs

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2011 The Apache Software Foundation. All Rights Reserved.